
#include "Unit.h"

const int buttons = 4;                         // number of Meni Buttons (big ones)
const int broj_textura = 25;                   // number of textures
const int broj_lista = 28;                     // number of display lists

bool	keys[256];		       // Array Used For The Keyboard Routine
bool	active=TRUE;		       // Window Active Flag Set To TRUE By Defaul
bool	done=FALSE;		       // Bool Variable To Exit Loop
bool    g_bPause;                      // For sleeping

bool    EnableSound=false;      // Sound :    on  or  off
bool    Mode=true;              // Mode  :  timetrial or normal
bool    HelpOn=false;           // Help  :    on  or  off
bool    Paused=false;           // Pause :    on  or  off
bool    StartTimer=false;       // da vreme pocne da tece tek kad se klikne na neki od objekata
bool    GameOver=false;
bool    NewGame=false;
bool    All=false;              // All objects are flipped
bool    Reseting = false;

bool	pd;					// PageDown pressed?
bool    sp;                                     // Space pressed?
bool    esc;                                    // Escape pressed?
bool    blend;				        // Blending OFF/ON?

typedef struct  {
	float	dir;		// direction             -1   +1
	bool    lock;           // lock object after it's been coupled
 	float	yrot;           // object rotation       0 - 180 degrees
 	int     number;         // object number         for   pairing    1 - 8
 	GLuint  list;           // for display list

} objects;

objects object[16];

typedef struct  {
	bool    down;           // pressed ?
        float   zpos;           // button translation (Z axis)
        float   dir;            // translation direction*/
} button;

button Button[buttons];


float roll1;
float roll2;

GLuint	box;					// Storage For The Display List
GLuint	top;					// Storage For The Second Display List

GLuint	texture[broj_textura];			// Storage For Textures

int     prvi,drugi,Index,mnozac,counter,MoveCounter,TotalMoves,Oktava,Poena;

int     Sec1,Sec2;                 // timer variables
int     Min=2;

int     ToggleSound=1;
int     ToggleMode;
int     ToggleScoreBoard=5;


int Score[10];
char Name[10][255];

char NewScore[10];
int  brojac;
int  index2=-1;

GLfloat LightAmbient[]=		{ 0.5f, 0.5f, 0.5f, 0.2f };
GLfloat LightDiffuse[]=		{ 1.0f, 1.0f, 1.0f, 0.2f };
GLfloat LightPosition[]=	{ 0.0f, 0.0f, -52.0f, 0.2f };




LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

AUX_RGBImageRec *LoadBMP(char *Filename)				// Loads A Bitmap Image
{
	FILE *File=NULL;									// File Handle

	if (!Filename)										// Make Sure A Filename Was Given
	{
		return NULL;									// If Not Return NULL
	}

	File=fopen(Filename,"r");							// Check To See If The File Exists

	if (File)											// Does The File Exist?
	{
		fclose(File);									// Close The Handle
		return auxDIBImageLoad(Filename);				// Load The Bitmap And Return A Pointer
	}

	return NULL;										// If Load Failed Return NULL
}

void readstr(FILE *f,char *string)
{
	do
	{
		fgets(string, 255, f);
	} while ((string[0] == '/') || (string[0] == '\n'));
	return;
}

void RetrieveData()
{
	FILE *filein;
	char oneline[255];
	int loop;

	filein = fopen("data/Scores.txt", "rt");				// File To Load World Data From
	readstr(filein,oneline);
	sscanf(oneline, "%i", &mnozac);

        for ( loop = 0; loop < 5; loop++)
	{
	     readstr(filein,oneline);
	     sscanf(oneline, "%i ", &Score[loop] );
        }

	for ( loop = 0; loop < 5; loop++)
	{
	     readstr(filein,oneline);
	     sscanf(oneline, "%s ", Name[loop]);
	}
	for ( loop = 5; loop < 10; loop++)
	{
	     readstr(filein,oneline);
	     sscanf(oneline, "%i ", &Score[loop]);
        }

	for ( loop = 5; loop < 10; loop++)
	{
	     readstr(filein,oneline);
	     sscanf(oneline, "%s ", Name[loop]);
	}

	fclose(filein);
	return;
}
void PutData()
{
	FILE *filein;
	char oneline[255];
	int loop;

	filein = fopen("data/Scores.txt", "wt");				// File To Load World Data From

        sprintf(oneline,"%i\n", mnozac );
        fputs(oneline,filein);

	for ( loop = 0; loop < 5; loop++)
	{
	     sprintf(oneline, "%i\n", Score[loop]);
             fputs(oneline,filein);
        }

	for ( loop = 0; loop < 5; loop++)
	{
	     sprintf(oneline, "%s\n", Name[loop] );
             fputs(oneline,filein);
        }

	for ( loop = 5; loop < 10; loop++)
	{
	     sprintf(oneline, "%i\n", Score[loop]);
             fputs(oneline,filein);
        }

	for ( loop = 5; loop < 10; loop++)
	{
	     sprintf(oneline, "%s\n", Name[loop] );
             fputs(oneline,filein);
        }
	fclose(filein);
	return;
}

void RandomFunc( )
{
        int array[8] = {0,0,0,0,0,0,0,0};
        int n;
        int i = 0;

        top = box + 1;
        while( i < 16 )
        {
              n = (rand() % ( 8 * mnozac + 1))/mnozac;
              if( array[n] < 2 )
              {
                    object[i].number = n;
                    object[i].list = top + n + 1;
                    array[n]++;
                    i++;
              }
        }
}
void CalculateFrameRate()
{
	static float framesPerSecond    = 0.0f;							// This will store our fps
    static float lastTime			= 0.0f;							// This will hold the time from the last frame
	static char strFrameRate[50] = {0};								// We will store the string here for the window title

    float currentTime = GetTickCount() * 0.001f;

	// Increase the frame counter
    ++framesPerSecond;

    if( currentTime - lastTime > 1.0f )
    {
	    lastTime = currentTime;
            if(StartTimer)
            {
          	if( !Paused)
                {
                Sec1--;
                if(Sec1 < 0)
                {
                     Sec1 = 9;
                     Sec2--;
                }
                if( Sec2 < 0)
                {
                     Sec2 = 5;
                     Min--;
                }
                }
            }
		// Copy the frames per second into a string to display in the window title bar
		sprintf(strFrameRate, "FPS: %d", int(framesPerSecond));


            framesPerSecond = 0;
    }
    	glLoadIdentity();
        glTranslatef(0.0f,0.0f,-10.0f);
        glColor3f(0.0f,0.0f,0.0f);
	glRasterPos2f(-4.0f, 2.55f);
 	glPrint(strFrameRate);
        glColor3f(1.0f,1.0f,1.0f);

}

GLvoid BuildLists()
{

        int i,m;
	box=glGenLists(broj_lista);									// Generate 2 Different Lists
	glNewList(box,GL_COMPILE);							// Start With The Box List
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	glBegin(GL_QUADS);
		// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-3.0f, -3.0f,  0.5f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 3.0f, -3.0f,  0.5f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 3.0f,  3.0f,  0.5f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-3.0f,  3.0f,  0.5f);
		// Top Face
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-3.0f,  3.0f, -0.5f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-3.0f,  3.0f,  0.5f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 3.0f,  3.0f,  0.5f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 3.0f,  3.0f, -0.5f);
		// Bottom Face
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-3.0f, -3.0f, -0.5f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 3.0f, -3.0f, -0.5f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 3.0f, -3.0f,  0.5f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-3.0f, -3.0f,  0.5f);
		// Right face
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 3.0f, -3.0f, -0.5f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 3.0f,  3.0f, -0.5f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 3.0f,  3.0f,  0.5f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 3.0f, -3.0f,  0.5f);
		// Left Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-3.0f, -3.0f, -0.5f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-3.0f, -3.0f,  0.5f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-3.0f,  3.0f,  0.5f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-3.0f,  3.0f, -0.5f);
		glEnd();
	glEndList();

	top = box + 1;

        //    E X   P I C T U R E S   //

        for( i = 0; i < 16; i++ )
        {
        	if( i < 8 )
        	     m = i;
        	else
                     m = i - 8;
                glNewList(top++,GL_COMPILE);							// New Compiled top Display List
                glBindTexture(GL_TEXTURE_2D, texture[ m + 1 ]);
                glBegin(GL_QUADS);
		// Back Face
                        glTexCoord2f(1.0f, 0.0f); glVertex3f(-3.0f, -3.0f, -0.5f);
		        glTexCoord2f(1.0f, 1.0f); glVertex3f(-3.0f,  3.0f, -0.5f);
		        glTexCoord2f(0.0f, 1.0f); glVertex3f( 3.0f,  3.0f, -0.5f);
		        glTexCoord2f(0.0f, 0.0f); glVertex3f( 3.0f, -3.0f, -0.5f);
	        glEnd();
                glEndList();
        }

        //      M E N I   B U T T O N S    //

        for( i = 0; i < buttons; i++ )
        {
                glNewList(top++,GL_COMPILE);							// New Compiled top Display List
                glBindTexture(GL_TEXTURE_2D, texture[ 10 + i ]);
                glBegin(GL_QUADS);
                                  // Front Face
		        glTexCoord2f(0.0f, 0.0f); glVertex3f(-3.0f, -1.0f,  0.0f);
		        glTexCoord2f(1.0f, 0.0f); glVertex3f( 3.0f, -1.0f,  0.0f);
		        glTexCoord2f(1.0f, 1.0f); glVertex3f( 3.0f,  1.0f,  0.0f);
		        glTexCoord2f(0.0f, 1.0f); glVertex3f(-3.0f,  1.0f,  0.0f);
  	         glEnd();
                 glEndList();
        }

        //      A B O U T   &   E X I T      //

        for( i = 0; i < 2; i++ )
        {

                glNewList(top++,GL_COMPILE);							// New Compiled top Display List
                glBindTexture(GL_TEXTURE_2D, texture[ 14 + i ]);
                glBegin(GL_QUADS);
                                  // Front Face
		        glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.5f, -0.5f,  0.0f);
		        glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.5f, -0.5f,  0.0f);
		        glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.5f,  0.5f,  0.0f);
		        glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.5f,  0.5f,  0.0f);
  	         glEnd();
                 glEndList();
        }

        //      S C O R E B O A R D      //

                 glNewList(top++,GL_COMPILE);
                 glBindTexture(GL_TEXTURE_2D, texture[16]);
	         glBegin(GL_QUADS);
		                  // ScoreBoard
		        glTexCoord2f(0.0f, 0.0f); glVertex3f(-4.0f, -6.0f,  0.0f);
		        glTexCoord2f(1.0f, 0.0f); glVertex3f( 4.0f, -6.0f,  0.0f);
		        glTexCoord2f(1.0f, 1.0f); glVertex3f( 4.0f,  6.0f,  0.0f);
		        glTexCoord2f(0.0f, 1.0f); glVertex3f(-4.0f,  6.0f,  0.0f);
	         glEnd();
                 glEndList();

        //         S O U N D          //

        for( i = 0; i < 2; i++ )
        {
                glNewList(top++,GL_COMPILE);
                glBindTexture(GL_TEXTURE_2D, texture[17 + i]);
	        glBegin(GL_QUADS);
		                  // Sound
		        glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  0.5f);
		        glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  0.5f);
		        glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  0.5f);
		        glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  0.5f);
	        glEnd();
                glEndList();
        }

        //     M O D E     //

        for( i = 0; i < 2; i++ )
        {
                glNewList(top++,GL_COMPILE);
                glBindTexture(GL_TEXTURE_2D, texture[19 + i]);
	        glBegin(GL_QUADS);
		                 // Mode
		       glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.5f, -0.5f,  0.5f);
		       glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.5f, -0.5f,  0.5f);
		       glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.5f,  0.5f,  0.5f);
		       glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.5f,  0.5f,  0.5f);
	        glEnd();
	        glEndList();
        }

        //     T I M E R    //

                glNewList(top++,GL_COMPILE);
                glBindTexture(GL_TEXTURE_2D, texture[21]);
	        glBegin(GL_QUADS);
		// Mode
		       glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.5f, -0.5f,  0.5f);
		       glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.5f, -0.5f,  0.5f);
		       glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.5f,  0.5f,  0.5f);
		       glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.5f,  0.5f,  0.5f);
	        glEnd();
                glEndList();


}


int LoadGLTextures()									// Load Bitmaps And Convert To Textures
{
	int Status=FALSE;									// Status Indicator

	AUX_RGBImageRec *TextureImage[broj_textura];					// Create Storage Space For The Texture

	memset(TextureImage,0,sizeof(void *)*1);           	// Set The Pointer To NULL

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if ((TextureImage[0]=LoadBMP("Data/NeHe.bmp"))
          &&(TextureImage[1]=LoadBMP("Data/ex1.bmp"))      // ck
          &&(TextureImage[2]=LoadBMP("Data/ex2.bmp"))      // micu
          &&(TextureImage[3]=LoadBMP("Data/ex3.bmp"))      // mek
          &&(TextureImage[4]=LoadBMP("Data/ex4.bmp"))      // xx
          &&(TextureImage[5]=LoadBMP("Data/ex5.bmp"))      // v
          &&(TextureImage[6]=LoadBMP("Data/ex6.bmp"))      // S
          &&(TextureImage[7]=LoadBMP("Data/ex7.bmp"))      // $
          &&(TextureImage[8]=LoadBMP("Data/ex8.bmp"))      // dex
          &&(TextureImage[9]=LoadBMP("Data/meni.bmp"))
          &&(TextureImage[10]=LoadBMP("Data/New.bmp"))
          &&(TextureImage[11]=LoadBMP("Data/Mode.bmp"))
          &&(TextureImage[12]=LoadBMP("Data/Sound.bmp"))
          &&(TextureImage[13]=LoadBMP("Data/Help.bmp"))
          &&(TextureImage[14]=LoadBMP("Data/About.bmp"))
          &&(TextureImage[15]=LoadBMP("Data/Exit.bmp"))
          &&(TextureImage[16]=LoadBMP("Data/ScoreBoard.bmp"))
          &&(TextureImage[17]=LoadBMP("Data/SpeakerON.bmp"))
          &&(TextureImage[18]=LoadBMP("Data/SpeakerOFF.bmp"))
          &&(TextureImage[19]=LoadBMP("Data/TimeTrial.bmp"))
          &&(TextureImage[20]=LoadBMP("Data/Normal.bmp"))
          &&(TextureImage[21]=LoadBMP("Data/Timer.bmp"))
          &&(TextureImage[22]=LoadBMP("Data/GameOver.bmp"))
          &&(TextureImage[23]=LoadBMP("Data/Paused.bmp"))
          &&(TextureImage[24]=LoadBMP("Data/Blinker.bmp")))
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(broj_textura, texture);					// Create The Texture

		// Typical Texture Generation Using Data From The Bitmap
		for ( int i = 0; i < broj_textura; i++)
		{
		     glBindTexture(GL_TEXTURE_2D, texture[i]);
		     glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
                     glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_NEAREST);
                     gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[i]->sizeX, TextureImage[i]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[i]->data); // ( NEW )
                }
	}

	for( int loop = 0; loop < broj_textura; loop++ )						// Loop Through All 5 Textures
	{
		if (TextureImage[loop])						// If Texture Exists
		{
			if (TextureImage[loop]->data)				// If Texture Image Exists
			{
				free(TextureImage[loop]->data);			// Free The Texture Image Memory
			}
			free(TextureImage[loop]);				// Free The Image Structure
		}
	}
	return Status;										// Return The Status
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	gluPerspective(30.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
        RetrieveData();
        for( int i = 0; i < 16 ; i++ )                      // initialize objects
        {
             object[i].dir = 1.0;
        }
        for( i = 0; i < buttons ; i++ )                 // initialize Buttons
        {
             Button[i].dir = 1.0;
        }

        RandomFunc( );

	if (!LoadGLTextures())								// Jump To Texture Loading Routine ( NEW )
	{
		return FALSE;									// If Texture Didn't Load Return FALSE
	}
	BuildLists();										// Jump To The Code That Creates Our Display Lists

	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping ( NEW )
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.27f, 0.3f, 0.0f);				// Black Background
	glClearDepth(1.0f);
        glEnable(GL_COLOR_MATERIAL);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations

	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);		// Setup The Ambient Light
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);		// Setup The Diffuse Light
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);	// Position The Light
	glEnable(GL_LIGHT1);								// Enable Light One

	glColor4f(0.3f, 0.3f, 0.3f, 1.0f);					// Full Brightness.  50% Alpha
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);					// Set The Blending Function For Translucency

        BuildFont();
        BuildFontItal();
        BuildFont3D();										// Build The Font

	return TRUE;										// Initialization Went OK
}
void ResetObjects( )
{
        counter = 0;
        ++mnozac = mod( mnozac, 99);
        for( int i = 0; i < 16 ; i++ )
        {
                object[i].dir = -1.0f;
                object[i].lock = true;
        }
        Reseting = true;
   //     GameOver = false;

}
void ResetFunc( )
{
  //      StartTimer = false;
  if( NewGame )
  {
        Min = 2;
        Sec1 = 0;
        Sec2 = 0;
        Poena = 0;
        TotalMoves = 0;
        MoveCounter = 0;
        Oktava = 0;
        StartTimer = false;
        GameOver = false;
        NewGame = false;
        HelpOn = false;
  }
        RandomFunc();
}

//========================================================================
//=======================  R O T A T E   B A C K    ======================
//========================================================================

void RotateBack(int index )
{
     Paused = false;
     roll2 = 0.0f;
     if( EnableSound )
          PlaySound("data/Sound.wav",NULL,SND_ASYNC);

     object[index].lock = true;

     if( counter == 2)
     {
     	  counter--;
     	  counter--;
          if( object[prvi].number != object[drugi].number )
          {
                object[prvi].dir = ( object[prvi].dir == 1.0f ? object[prvi].dir - 2.0f : object[prvi].dir + 2.0f );
                object[drugi].dir = ( object[drugi].dir == 1.0f ? object[drugi].dir - 2.0f : object[drugi].dir + 2.0f );
          }
     }
     if( ++counter <= 1 )
     {
          prvi = index;
     }
     else
     {
          drugi = index;
          if( object[prvi].number == object[drugi].number)
          {
          	if( !Paused)
          	    MoveCounter++;
          }
          if( !Paused)
                TotalMoves++;
          if(( MoveCounter > 0 ) && (( MoveCounter % 8) == 0 ))
          {
          	Oktava++;
          	MoveCounter = 0;
          	All = true;
          	Index = index;
          }
     }
}

//========================================================================
//=======================  D R A W   T A R G E T S  ======================
//========================================================================

void DrawTargets(void)											// Draws The Targets (Needs To Be Seperate)
{
        int i;
        glLoadIdentity();
	if(blend)
	{
		glEnable(GL_BLEND);			// Turn Blending On
		glDisable(GL_DEPTH_TEST);	// Turn Depth Testing Off
        }
	top = box + 17;
        for( i = 0; i < 16 ; i++ )
        {
             glPushName(CONS + i);
             glPushMatrix ( );

	     glTranslatef(position[i][0],position[i][1],position[i][2]);
	     glRotatef(object[i].yrot,0.0f,1.0f,0.0f);

             glCallList(box);
             glCallList(object[i].list);

             glPopMatrix ( );
             glPopName();
        }
        if(blend)
        {
	     glDisable(GL_BLEND);		// Turn Blending Off
	     glEnable(GL_DEPTH_TEST);	// Turn Depth Testing On
        }
        for( i = 0; i < buttons ; i++ )
        {
             glPushName(CONS + 16 + i);
             glPushMatrix ( );

             glTranslatef(15.0f,11.5f - 2.0f * i , -48.0f - Button[i].zpos);

             glCallList(top++);

             glPopMatrix ( );
             glPopName();
        }
             // ABOUT       //
             glPushName(CONS + 20);
             glPushMatrix ( );

             glTranslatef(13.0f, -11.8f , -48.0f);

             glCallList(top++);

             glPopMatrix ( );
             glPopName();
             // EXIT        //
             glPushName(CONS + 21);
             glPushMatrix ( );

             glTranslatef(17.0f, -11.8f , -48.0f);

             glCallList(top++);

             glPopMatrix ( );
             glPopName();

}

//========================================================================
//============================  S E L E C T I O N   ======================
//========================================================================


int RetrieveObjectID(int x, int y)
{
	int objectsFound = 0;								// This will hold the amount of objects clicked
	int	viewportCoords[4] = {0};						// We need an array to hold our view port coordinates

	unsigned int selectBuffer[512] = {0};


	glSelectBuffer(32, selectBuffer);					// Setup our selection buffer to accept object ID's
	glGetIntegerv(GL_VIEWPORT, viewportCoords);			// Get the current view port coordinates
	glMatrixMode(GL_PROJECTION);						// We want to now effect our projection matrix
	glPushMatrix();										// We push on a new matrix so we don't effect our 3D projection

		glRenderMode(GL_SELECT);						// Allows us to render the objects, but not change the frame buffer
		glLoadIdentity();								// Reset our projection matrix
		gluPickMatrix(x, viewportCoords[3] - y, 2, 2, viewportCoords);
		gluPerspective(30.0f, (GLfloat) (viewportCoords[2]-viewportCoords[0])/(GLfloat) (viewportCoords[3]-viewportCoords[1]),0.1f,150.0f);
		glMatrixMode(GL_MODELVIEW);
                glLoadIdentity();						// Go back into our model view matrix
                DrawTargets();

		objectsFound = glRenderMode(GL_RENDER);			// Return to render mode and get the number of objects found

		glMatrixMode(GL_PROJECTION);					// Put our projection matrix back to normal.
        	glPopMatrix();										// Stop effecting our projection matrix

	        glMatrixMode(GL_MODELVIEW);							// Go back to our normal model view matrix

                return selectBuffer[3];

}
//================================================================================
//=========================  D R A W   S C O R E S   =============================
//================================================================================

void DrawScores()
{
    	glLoadIdentity();
	glColor3f(0.0f,0.0f,0.0f);
        glTranslatef(0.0f,0.0f,-10.0f);
        glRasterPos2f(2.65f, -0.7f );
        glPrint("Best Scores Ever :");
        for( int i = 0; i < 5; i++)
        {
            glRasterPos2f(2.45f, -1.f - 0.15f*i);
            glPrint("%i. ",i+1);
            glPrint("%s",Name[i + ToggleScoreBoard]);
            if(Score[i + ToggleScoreBoard]>1000)
               glRasterPos2f(3.53f, -1.0f - 0.15f*i);
            else
               glRasterPos2f(3.60f, -1.0f - 0.15f*i);
            glPrint("%i", Score[i + ToggleScoreBoard]);
        }
      //  glTranslatef(0.0f,0.0f,-40.0f);
        glRasterPos2f(2.55f, -2.1f );
        glPrint("Press Space For Break");
}

//================================================================================
//========================  D  I  S  P  L  A  Y   ================================
//================================================================================

int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{

        int i;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glColor3f(1.0f,1.0f,1.0f);
 	glLoadIdentity();
	glTranslatef(16.0f,0.0f,-49.4f);
        glBindTexture(GL_TEXTURE_2D, texture[9]);
	glBegin(GL_QUADS);
		// meni
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-5.0f, -15.0f,  0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 5.0f, -15.0f,  0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 5.0f,  15.6f,  0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-5.0f,  15.6f,  0.0f);
	glEnd();

        glLoadIdentity();
        glTranslatef(0.0f,0.0f,-10.0f);
        glColor3f(0.0f,0.0f,0.0f);

        if(!HelpOn)
        {
                DrawScores();
        }
        else
        {

                for(i = 0; i < 12; i++ )
                {
                       glRasterPos2f(2.35f, -0.2f - 0.15f*i);
                       glPrint("%s",HelpText[i]);
                }
        }

        if( Mode )                               // timetrial mode
        {
             glRasterPos2f(3.2f, 0.4f);
 	     glPrint(" %i:%i%i",Min,Sec2,Sec1);
 	}
 	else                                     //  normal mode
 	{
             glRasterPos2f(3.33f, 0.4f);
             glPrint("/");
             if ( Oktava*8 + MoveCounter > 9)
                 glRasterPos2f(3.15f, 0.4f);
             else
                 glRasterPos2f(3.23f, 0.4f);
             glPrint("%i",Oktava*8 + MoveCounter);
             glRasterPos2f(3.43f, 0.4f);
             glPrint("%i",TotalMoves);
        }
        glColor3f(1.0f,1.0f,1.0f);
        

        DrawTargets();
        CalculateFrameRate();

        glLoadIdentity();
        glTranslatef(15.3f,-5.0f,-49.0f);
        glCallList(top++);                                     // ScoreBoard

	glLoadIdentity();
        glTranslatef(13.5f,2.6f,-49.0f);
        glCallList( top++ + ToggleSound); top++;               // Sound

	glLoadIdentity();
        glTranslatef(16.3f,3.1f,-49.0f);
        glCallList( top++ + ToggleMode);  top++;               // Mode

	glLoadIdentity();
        glTranslatef(16.3f,2.1f,-49.0f);
        glCallList(top++);                                     // Timer

    for( i = 0; i < 16 ; i++ )
    {
         if( object[i].lock )
         {
                object[i].yrot = limited ( 0.0f , 180.0f , object[i].yrot + 10.0f * object[i].dir );
	        if( object[i].yrot == 0.0f )
                {
                     object[i].lock = false;
                     object[i].dir = ( object[i].dir == 1.0f ? object[i].dir - 2.0f : object[i].dir + 2.0f );
                }
	        if(( All )&&( object[Index].yrot == 180.0f ))
                {
                     	   ResetObjects();
                     	   All = false;
                }
          }
    }

    for( i = 0; i < buttons ; i++ )
    {
        if( Button[i].down )
        {
                Button[i].zpos = limited ( 0.0f , 0.3f , Button[i].zpos + 0.1f * Button[i].dir );
	        if( Button[i].zpos == 0.3f )
                {
                     Button[i].dir = ( Button[i].dir == 1.0f ? Button[i].dir - 2.0f : Button[i].dir + 2.0f );
                }
	        if( Button[i].zpos == 0.0f )
                {
                     Button[i].down = false;
                     Button[i].dir = ( Button[i].dir == 1.0f ? Button[i].dir - 2.0f : Button[i].dir + 2.0f );
                }
         }
    }
    if ((Reseting)&&(object[prvi].lock == false))
    {
    	ResetFunc();
    	Reseting = false;
    }

/*    	glLoadIdentity();
        glTranslatef(0.0f,0.0f,-10.0f);
        glRasterPos2f(-1.0f, 0.0f );
    for(int m=0;m<16;m++)
    {
         for(int k=0;k<16;k++)
         {
    	      if(keys[16*m+k])
    	          glPrint("I");
    	      else
    	          glPrint("o");
         }
     }    */

    if( GameOver )
    {
    	glLoadIdentity();
    	glEnable(GL_BLEND);			// Turn Blending On
	glDisable(GL_DEPTH_TEST);	// Turn Depth Testing Off

        glColor4f(1.0f, 0.5f, 0.0f, roll1 );
	glTranslatef(-4.5f,0.0f,-49.45f);
	glBindTexture(GL_TEXTURE_2D, texture[22]);                             // game over
	glBegin(GL_QUADS);
		// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-7.5f, -1.5f,  0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 7.5f, -1.5f,  0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 7.5f,  1.5f,  0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-7.5f,  1.5f,  0.0f);
        glEnd();

	glDisable(GL_BLEND);		// Turn Blending Off
	glEnable(GL_DEPTH_TEST);	// Turn Depth Testing On

  	roll1 = limited(0.0f,1.0f, roll1 + 0.03f);			// Increase Our Texture Roll Variable

        glLoadIdentity();
        glColor3f(1.0f,1.0f,1.0f);
	glTranslatef(12.5f,-1.05f,-40.0f);
	glBindTexture(GL_TEXTURE_2D, texture[24]);                             // blinker?
	glBegin(GL_QUADS);
		// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-3.0f, -0.25f,  0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 3.0f, -0.25f,  0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 3.0f,  0.25f,  0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-3.0f,  0.25f,  0.0f);
        glEnd();

    	glLoadIdentity();
        glColor3f(0.0f,0.0f,0.0f);
        glTranslatef(0.0f,0.0f,-10.0f);
        glRasterPos2f(2.85f, 0.0f );
        if(index2!=-1)
        {      
                glPrint("%i%s",index2-ToggleScoreBoard+1,Dodatak[index2-ToggleScoreBoard]);
                glPrint("  Place");
                glRasterPos2f(2.45f, -0.3f );
                glPrintItal("%s",NewScore);                      // echo 
        }
        else
        {
                glRasterPos2f(2.45f, -0.3f );
                glPrint("Your Score");
        }
        if(Poena > 1000)
               glRasterPos2f(3.53f,-0.3f );
            else
               glRasterPos2f(3.60f,-0.3f );
        glPrint("%i",Poena);
        glColor3f(1.0f,1.0f,1.0f);
    }

    if( (Paused) && (!GameOver) )
    {
    	glLoadIdentity();
    	glEnable(GL_BLEND);			                                // Turn Blending On
	glDisable(GL_DEPTH_TEST);	                                        // Turn Depth Testing Off
	glColor4f(1.0f, 0.5f, 0.0f, roll2 );
        glTranslatef(-4.1f,0.0f,-49.45f);
	glBindTexture(GL_TEXTURE_2D, texture[23]);                              // paused
	glBegin(GL_QUADS);
		// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-7.5f, -1.5f,  0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 7.5f, -1.5f,  0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 7.5f,  1.5f,  0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-7.5f,  1.5f,  0.0f);
        glEnd();
	glDisable(GL_BLEND);		                                        // Turn Blending Off
	glEnable(GL_DEPTH_TEST); 	                                        // Turn Depth Testing On
  	roll2 = limited(0.0f,1.0f, roll2 + 0.03f);				// Increase Our Texture Roll Variable
    }


    return TRUE;
         										// Keep Going
}
//================================================================================
//======================   C H E C K   N E W   P L A Y E R  ======================
//================================================================================

int CheckNewPlayer()
{
    for(int i = 0; i < 5; i++)
    {
    	if (Score[i + ToggleScoreBoard] < Poena)
    	{

    		return (i + ToggleScoreBoard);
    	}
    }
    return -1;
}

//================================================================================
//============================  G A M E   O V E R  ===============================
//================================================================================

void GameOverFunc()
{
    	if((!Reseting)&&(((Mode)&&(Min == 0)&&(Sec2 == 0)&&( Sec1 == 0))||((!Mode)&&( Oktava*8 + MoveCounter == 24))))
    	{
    		GameOver = true;
    		HelpOn = false;
    		StartTimer = false;
    		if(TotalMoves == 0)
    		   TotalMoves = 1;
    		if(Mode)
    		{
    		       Poena = (int)(((Oktava*8+MoveCounter)*100)+(Oktava*8+MoveCounter)*10/TotalMoves);
    		}
    		else
    		{
                       Poena = (int)((Oktava*8+MoveCounter)*1000/TotalMoves);
                }
    		index2 = CheckNewPlayer();
    	}
}
//================================================================================
//==================  R O T A T E   B A C K   C A L L E R   ======================
//================================================================================

void RotateBackCaller(int index)
{
        HelpOn = false;
        if( !StartTimer )
        {
           StartTimer = true;
           roll1 = 0.0f;
        }
	if((!GameOver)&&(!object[index].lock))
	{
		RotateBack(index);
        }
}
//================================================================================
//=========================    M O V E   D O W N    ==============================
//================================================================================

void MoveDown()
{
        int i;
        int granica=5;
        char PomName[10][255];
        int  PomScore[10];

        if(index2 >= 5)
        {
        	granica += 5;
        }
        for( i = 0; i < 9; i++ )
        {
        	strcpy(PomName[i+1],Name[i]);
        	PomScore[i+1] = Score[i];
        }
        for( i = index2; i < granica; i++ )
        {
                strcpy(Name[i],PomName[i]);
                Score[i] = PomScore[i];
        }

}

//================================================================================
//=====================  E N T E R  N E W   N A M E    ===========================
//================================================================================

void EnterNewName(int wParam)
{

                        if(wParam == 13)                 // enter
                        {
                                MoveDown();
                        	strcpy(Name[index2],NewScore);
                                for(int i = 0; i < brojac; i++)
                                {
                                     NewScore[i] = ' ';
                                }

                        	brojac = 0;
                                Score[index2] = Poena;
                                ResetObjects();
                                NewGame = true;
                        	return;
                        }
		        if(wParam == 8)                  // backspace
		        {
		        	if(brojac!=0)
		        	{
		        	     brojac--;
       		                     NewScore[brojac] = ' ';
       		                     return;
       		                }
		        }

		        if((wParam >= 32)&&(wParam <= 125))    // big and small letters
		        {
	                           if(brojac < 10)
	                           {

   		        	         if((wParam <=90)&&(wParam >=65))          //  convert big letters to small
		        	         {
                                               NewScore[brojac++] = wParam + 32;
                                         }
                                         else
                                         {
                                               NewScore[brojac++] = wParam;
                                         }
                                   }
                        }
}
//================================================================================
//=====================  C R E A T E   G L   W I N D O W     =====================
//================================================================================

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/

BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASSEX	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

//	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance		= GetModuleHandle(NULL);
        wc.cbSize        = sizeof(WNDCLASSEX);				// Grab An Instance For Our Window
	wc.style		= 0;//CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= /*(WNDPROC)*/ WndProc;					// WndProc Handles Messages
/**/	wc.cbClsExtra		= 0;									// No Extra Window Data
/**/	wc.cbWndExtra		= 0;									// No Extra Window Data
/**/	wc.hInstance		= hInstance;							// Set The Instance
/**/	wc.hIcon		= LoadIcon(NULL, IDI_APPLICATION);			// Load The Default Icon
/**/	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
/**/	wc.lpszClassName	= "OpenGL";
        wc.hIconSm              = LoadIcon(NULL, IDI_APPLICATION);

    // WndClass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	if (!RegisterClassEx(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

//================================================================================
//=============================  S W I T C H E R    ==============================
//================================================================================

void Switcher(int objectID)
{
                if((objectID>99)&&(objectID<116))
                {
                        RotateBackCaller(objectID - CONS);         // objects
                }
		switch(objectID)		 		   // Check the objectID passed back
		{
		case CONS + 16:                                    // new
		        Button[0].down = true;
   	                if((( StartTimer )&&( MessageBox(hWnd,"Are you sure you want to quit current game?","Quit Game"
                                                      ,MB_YESNO|MB_ICONEXCLAMATION)==IDYES))||(!StartTimer))
                        {
                             ResetObjects();
                             NewGame = true;
                        }
			break;
		case CONS + 17:                                    // mode
		        Button[1].down = true;
		        if((( StartTimer )&&( MessageBox(hWnd,"Are you sure you want to quit current game?","Quit Game"
                                                      ,MB_YESNO|MB_ICONEXCLAMATION)==IDYES))||(!StartTimer))
                        {
                             ResetObjects();
                             NewGame = true;
                             Mode = ( Mode == true ? false : true );
                             ToggleMode = ( Mode == true ? (0) : (1));
                             ToggleScoreBoard = ( Mode == false ? (0) : (5));
                        }
			break;
		case CONS + 18:                                    // sound
		        Button[2].down = true;
                        EnableSound = ( EnableSound == true ? false : true );
                        ToggleSound = ( EnableSound == true ? (0) : (1));
			break;
		case CONS + 19:                                    // help
		        Button[3].down = true;
		        if(!GameOver)
       	                    HelpOn = ( HelpOn == true ? false : true );
			break;
		case CONS + 20:                                    // about
                        MessageBox(hWnd,"MemoryBloX v1.0      13.11.2004\n\n                                   by kosta","About box",MB_OK|MB_ICONINFORMATION);
			break;
		case CONS + 21:                                    // exit
                     	done = true;
			break;
		}

}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information


{
        int objectID = 0;
	switch (uMsg)									// Check For Windows Messages
	{
		case WM_KILLFOCUS:
		{
                        g_bPause = true;
                        break;
                }
                case WM_SETFOCUS:
                {
                        g_bPause = false;
                        break;
                }
		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
		        if((GameOver)&&(index2>-1))
		        {
		        	EnterNewName(wParam);
                        }
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}

		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;
                }
   	        case WM_LBUTTONDOWN:
		{
                        Switcher(RetrieveObjectID(LOWORD(lParam), HIWORD(lParam)));
                        return 0;
		}
   //           case WM_ENTER:
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
	MSG		msg;									// Windows Message Structure

													   // 510,354
	// Create Our OpenGL Window
	if (!CreateGLWindow(" MemoryBloX v1.0 by Kosta ",1016,676,16,false))
	{
		return 0;									// Quit If Window Was Not Created
	}

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
                        if ( g_bPause )
                        {
                                Sleep(100);
                        }
                        else
                        {
                                DrawGLScene();
                                SwapBuffers(hDC);
                                GameOverFunc() ;
                        }
                                if (keys[VK_ESCAPE]&& !esc)
                                {
                                        done=TRUE;
                                        esc = !esc;
                                }
				if (!keys[VK_ESCAPE])
				{
					esc=FALSE;
				}

				if (keys[VK_NEXT]&& !pd)
				{
					pd=TRUE;
					blend = !blend;
				}
				if (!keys[VK_NEXT])
				{
					pd=FALSE;
				}

				if (keys['R'])
				{
					Min = Sec1 = Sec2 = 0;
				}
				if (keys[VK_SPACE] && !sp)
				{
					sp=TRUE;
					if(!GameOver)
					{
				             Paused = !Paused;
				        }
				        roll2 = 0.0f;
				}
				if (!keys[VK_SPACE])
				{
					sp=FALSE;
				}
		}
	}
	++mnozac = mod( mnozac, 99);
        PutData();
	// Shutdown
	KillGLWindow();
        KillFont();								// Kill The Window
	return (msg.wParam);							// Exit The Program
}
